﻿# -*- coding: utf-8 -*-


import copy
import math

#ブレンドターゲットの作成

#ウインドウデザインを変更　2010.11.10


#他ソフトのモーフミキサーみたいな感じで複数のターゲットをブレンドして
#変形ジョイント用の新しいモーフターゲットを作成します




#動作条件
#選択形状がポリゴンメッシュ
#上位パートに変換無し



#設定項目
#各ブレンド率
#名前・・・作成されたポリゴンメッシュの名前がこれになります



def return_henkan_pos(pos,mat):
  #posをmatで変換した座標（タプル）を返す
  tempx=pos[0]
  tempy=pos[1]
  tempz=pos[2]
  x1=mat[0][0]*tempx+mat[1][0]*tempy+mat[2][0]*tempz+mat[3][0]*1
  y1=mat[0][1]*tempx+mat[1][1]*tempy+mat[2][1]*tempz+mat[3][1]*1
  z1=mat[0][2]*tempx+mat[1][2]*tempy+mat[2][2]*tempz+mat[3][2]*1
  return [x1,y1,z1]




dousasuru=0

xscene=xshade.scene()
ashape=xshade.scene().active_shape()



if xshade.scene().active_shape().local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
  dousasuru=0
  dialog=xshade.create_dialog()
  dialog.append_push_button('上位パートに変換がかかっているため')
  dialog.append_push_button('スクリプトが実行できません')
    
  dialog.ask('エラー')

else:

  if ashape.type==7:

    dia=xshade.create_dialog()
    idxa1=dia.append_selection('ターゲットの数/1/2/3/4/5/6/7/8/9/10/11/12/13/14/15/16/17/18/19/20/21/22/23/24/25/26/27/28/29/30')
#    idxa1=dia.append_int('ターゲットの数')

    dia.set_value(idxa1,0)

    xshade.idle(10)
    kekkaa=dia.ask('ブレンドターゲットの作成')
    if kekkaa==True:
      #パート内のトップへ移動
#      targetnum=dia.get_value(idxa1)
#      if targetnum<1:targetnum=1
      targetnum=dia.get_value(idxa1)+1

      xscene.select_parent()
      numson=xshade.scene().active_shape().number_of_sons
      xscene.select_child()
      if numson>targetnum:
        #ターゲットは全てベースターゲットと同じコントロールポイントのポリゴンメッシュか?
        hantei=0
        ashapebase=xshade.scene().active_shape()
        basecpnum=ashapebase.total_number_of_control_points
        for i in range(targetnum):
          xscene.select_brother()
          if xscene.active_shape().type==7:
            if xscene.active_shape().total_number_of_control_points==basecpnum:
              hantei=hantei
            else:
              hantei+=1

          else:hantei+=1

        if hantei==0:dousasuru=1

      else:ashape.select()

    





if dousasuru==1:

  ashapebase.select()

  #適用率リスト作成

  tlist=[]
  idxaa=[]
  idxbb=[]
  boollist=[]


  for i in range(30):
    tlist.append(1)
    idxaa.append(0)
    idxbb.append(0)
    boollist.append(0)

  #名前リスト作成
  namelist=[]

  #ターゲットリスト作成
  
  for i in range(targetnum):
    xscene.select_brother()
    name1=xscene.active_shape().name
    namelist.append(name1)
  ashapebase.select()

  #ダイアログ表示
  dia3=xshade.create_dialog()
  idxname=dia3.append_string('名前')
  dia3.set_value(idxname,'ポリゴンメッシュ')
  for i in range(targetnum):
    dia3.begin_box(False)
    idxaa[i]=dia3.append_bool(namelist[i])
    idxbb[i]=dia3.append_float('適用率')
    dia3.set_value(idxaa[i],False)
    dia3.set_value(idxbb[i],tlist[i])
    dia3.end_box()


  xshade.idle(10)

  kekka33=dia3.ask('ブレンドターゲットの作成')

  if kekka33==True:
    resultname=dia3.get_value(idxname)

    for i in range(targetnum):
      boollist[i]=dia3.get_value(idxaa[i])
      tlist[i]=dia3.get_value(idxbb[i])

    #元の形状をクリップボードにコピー
    ashapebase.copy()

    #ターゲットの頂点位置リストを作成
    tposlist=[]
    for i in range(targetnum):
      xscene.select_brother()
      temp=[]
      for gg in range(basecpnum):
        temp.append(xscene.active_shape().vertex(gg).position)

      tposlist.append(temp)


    #結果を出力
    xscene.select_parent()
    sonson=xscene.active_shape().number_of_sons
    xscene.select_child()
    xscene.select_brother(sonson)
    xscene.paste()
    names='r'+resultname
    xscene.active_shape().name=names

    ashape2=xscene.active_shape()
    xscene.show_active()
    ashape2.render_flag=-1

    #各頂点を移動
    for gg in range(basecpnum):
      motop=ashape2.vertex(gg).position
      newp=motop

      for i in range(targetnum):

        if boollist[i]==True:
          temppos=tposlist[i][gg]
          temppos=((temppos[0]-motop[0])*tlist[i],(temppos[1]-motop[1])*tlist[i],(temppos[2]-motop[2])*tlist[i])
          newp=[newp[0]+temppos[0],newp[1]+temppos[1],newp[2]+temppos[2]]

      ashape2.vertex(gg).position=newp


    #メッセージウインドウに出力
    print names+':'
    for i in range(targetnum):
      if boollist[i]==True:
        temptex='　'+namelist[i]+'　適用率：'+str(tlist[i])
        print temptex



