﻿# -*- coding: utf-8 -*-


import copy


#表情のミラーコピー　2010.11.10

#Y軸を境に右側（あるいは左側）につけた表情を、反対側にコピーします

#動作条件
#選択形状がポリゴンメッシュ
#編集モードに入ってる
#頂点選択モード
#頂点がニ個以上選択されている
#上位パートに変換がかかっていない事
#基準形状（左右対称）が上か、下のパート内の先頭にある事





xscene=xshade.scene()
ashape=xshade.scene().active_shape()

error=0
dousasuru=0

#動作条件確認その1

if ashape.type==7 and xscene.is_modify_mode==True:
  if xscene.selection_mode==2:
    aplist=[]
    for i in range(ashape.total_number_of_control_points):
      if ashape.vertex(i).active==True:
        aplist.append(i)

    if len(aplist)>0:dousasuru=1
    else:error=2

    cpnum=ashape.total_number_of_control_points
  else:error=2

else:error=2


if dousasuru>0:
  #上位パートに変換がかかっているなら動作しない

  if xshade.scene().active_shape().local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
    dousasuru=0
    dialog=xshade.create_dialog()
    dialog.append_push_button('上位パートに変換がかかっているため')
    dialog.append_push_button('スクリプトが実行できません')
    
    dialog.ask('エラー')



if dousasuru==1:

  imamodify=xscene.is_modify_mode

  #元の形状をコピー
  ashape.copy()
  if imamodify==True:xscene.enter_modify_mode()


  #ダイアログ表示
  dia=xshade.create_dialog()
  dia.begin_group()
  idxa=dia.append_radio_button('基準形状の位置/選択形状の真下のパート内の先頭/選択形状の真上')
  dia.end_group()

  dia.begin_group()
  idxb=dia.append_radio_button('/選択頂点のみコピー/Y軸より右側を全て左側にコピー')
  dia.end_group()


  dia.set_value(idxa,0)
  dia.set_value(idxb,0)


  xshade.idle(10)
  kekkaa=dia.ask('表情のミラーコピー')

  if kekkaa==False:
    dousasuru=0

  else:
    oyaiti=dia.get_value(idxa)
    kasyo=dia.get_value(idxb)

    if kasyo==0:
      aplist2=copy.copy(aplist)
    else:
      aplist2=[]
      for i in range(ashape.total_number_of_control_points):
        if ashape.vertex(i).position[0]>0:
          aplist2.append(i)


    #親のチェック

    if oyaiti==0:
      if ashape.has_bro==True:
        if ashape.bro.type==2:
          if ashape.bro.has_son==False:
            error=1
            dousasuru=0
        else:
          error=1
          dousasuru=0

      else:
        error=1
        dousasuru=0


      if dousasuru==1:
        ashape.bro.select()
        xscene.select_child()
        oya=xshade.scene().active_shape()
        ashape.select()

        if oya.type==7:
          if oya.total_number_of_control_points!=cpnum:
            error=1
            dousasuru=0

        else:
          error=1
          dousasuru=0
#          print 15

        #上位パートに変換がかかってないか?
        if oya.local_to_world_matrix!=((1.0, 0.0, 0.0, 0.0), (0.0, 1.0, 0.0, 0.0), (0.0, 0.0, 1.0, 0.0), (0.0, 0.0, 0.0, 1.0)):
          dousasuru=0
          dialog=xshade.create_dialog()
          dialog.append_push_button('基準形状の上位パートに')
          dialog.append_push_button('変換がかかっているため')
          dialog.append_push_button('スクリプトが実行できません')
          xshade.idle(10)

          dialog.ask('エラー')



    if oyaiti==1:
      if ashape.has_sis==True:
        if ashape.sis.type==7:
          if ashape.total_number_of_control_points==cpnum:
            oya=ashape.sis
          else:
            error=1
            dousasuru=0


        else:
          error=1
          dousasuru=0
          

      else:
        error=1
        dousasuru=0



    if dousasuru==1:
      #選択頂点のx座標値を反転したリストを作成
      vlist=[]
      for i in aplist2:
        tempos=ashape.vertex(i).position
        tempos=[-tempos[0],tempos[1],tempos[2]]
        vlist.append(tempos)

      #基準形状を元に選択頂点の反対側の頂点リストを作成
      iplist=[]
      for i in aplist2:
        tempos=oya.vertex(i).position
        tempos=[-tempos[0],tempos[1],tempos[2]]

        hantei=0
        for gg in range(cpnum):
          temp2=oya.vertex(gg).position
          if ((temp2[0]-tempos[0])**2+(temp2[1]-tempos[1])**2+(temp2[2]-tempos[2])**2)<0.001:
            iplist.append(gg)
            hantei+=1
            break

        if hantei==0:
          iplist.append(-1)
#          dousasuru=0
#          di4=xshade.create_dialog()
#          di4.append_push_button('左右対称でない頂点が')
#          di4.append_push_button('選択されています')
#          di4.ask('エラー')

      if dousasuru==1:

        #表情をコピー
        for i in range(len(iplist)):
#          ashape.vertex(iplist[i]).position=vlist[i]
          if iplist[i]!=-1:
            ashape.vertex(iplist[i]).position=vlist[i]



        #元に戻す？
        dialog=xshade.create_dialog()
        idx3=dialog.append_push_button('処理を確定しますか？')
#        if imamodify==1:
#          xshade.scene().enter_modify_mode()
        xshade.idle(10)

        kekka=dialog.ask('表情のミラーコピー')

        #キャンセルなら形状を削除してクリップボードの形状を元に戻す

        #さらに頂点や辺の選択状態も元に戻す？
        if kekka==False:
          idou1=0
          if xshade.scene().active_shape().has_sis==True:
            idou1=1
          xshade.scene().paste()
          xshade.scene().select_sister(1)
          xshade.scene().clear()
          if idou1==1:
            xshade.scene().select_brother()
          if imamodify==1:
            xshade.scene().enter_modify_mode()
          ashape=xshade.scene().active_shape()

          for i in aplist:
            xshade.scene().active_shape().vertex(i).active=True

        if kekka==True:
          if imamodify==1:
            xscene.enter_modify_mode()


if error==1:
  dia55=xshade.create_dialog()
  dia55.append_push_button('基準形状が不正です')
  xshade.idle(10)

  dia55.ask('エラー')


if error==2:
  dia55=xshade.create_dialog()
  dia55.append_push_button('ポリゴンメッシュを選択し')
  dia55.append_push_button('編集モードに入って')
  dia55.append_push_button('頂点を一つ以上選択して')
  dia55.append_push_button('ください')

  dia55.ask('エラー')

